extern int     AnalyzeDays.Count          =  12;
extern int     AnalyzeDays.OffsetHrs      =  16;
void OptMapParameters(){
   OptMapToInt   ("TZselect.Brk0_UTC1_NY2      ", TZselect.Brk0_UTC1_NY2      );
   OptMapToDouble("Trade.Hr.Start              ", Trade.Hr.Start              );
   OptMapToDouble("Trade.Hr.End                ", Trade.Hr.End                );
   :
//+------------------------------------------------------------------+
//| Multi-Optimization functions                                     |
//+------------------------------------------------------------------+
//{The .opt file format:
// " har% geo% $tot #cnt/mod/nxt<tab>N1=V1<tab>N2=V2<tab>...<tab>"
// Where har      is harmonic mean of return rates
//       geo      is geometric mean of RR. (Only depends of final total.)
//       tot      is total balance from all runs
//       cnt      is pass number from previous run (Opt_Mode-1)/Opt_Counter
//       nxt      is line count for this run.
   #define  OPT_HAR_BEG           0
   #define  OPT_HAR_LEN           5
   #define  OPT_HAR_SEP          "%"
   #define  OPT_GEO_BEG           6
   #define  OPT_GEO_LEN           5
   #define  OPT_GEO_SEP          "% $"
   #define  OPT_BAL_BEG          14             // start + len = 6 + 5 + 3
   #define  OPT_BAL_LEN          11
   #define  OPT_BAL_SEP          " #"
   #define  OPT_PASS_BEG         27
   #define  OPT_PASS_LEN          5
   #define  OPT_PASS_SEP         "/"
   #define  Opt_Mode_BEG         33             // variable length 1 or 2
   #define  Opt_Mode_SEP         "/"            // len=1
   #define  OPT_NEXT_LEN_MIN      4
   #define  OPT_NEXT_SEP         "\t"  // TAB
   #define  OPT_NAME_SEP         "="
   #define  OPT_NAME_SEP_LEN      1
   #define  OPT_VAL_SEP          "\t"
   #define  OPT_VAL_SEP_LEN       1
//}File format
double   opt_balance[99];                          // \ Export to
int      opt_next;                                 // / OptComplete
void     OptInitialization(){
   opt_balance[0]  = AccountBalance();    // Remember for profit calculation.
   opt_next    = 1;                       // Assume first pass this mode.
   if(Opt_Mode > 0) if(Opt_Counter < 1){  AlertMe(
         "OptParameters: Pass=" + Opt_Counter + "/" + Opt_Mode + " (invalid)" );
      Opt_Mode = EMPTY;                                              return;  }
      string   nameOPT  = WindowExpertName() + ".OPT";
   int      handleOPT   = FileOpen(nameOPT, FILE_CSV|FILE_READ, '~');
   if(handleOPT < 1){
      if(Opt_Mode > 0){ Opt_Mode = EMPTY; AlertMe( "OptInitialization: FileOpen(",
                                    nameOPT,") Failed: ", GetLastError() );   }
      else{ // First pass of initial optimization. Externals are set by tester.
         Log( "#    1/0/1 inputs: ", OptGetParameters() );  }
      return;
   }
   bool     hasSetParms = (Opt_Mode == 0);         // mode==0 set by tester.
   int      wantNext    = Opt_Counter;
   for(int mode = Opt_Mode - 1; mode >= 0; mode--){
      string   modeNext = mode + Opt_Mode_SEP
                        + LJust(wantNext, OPT_NEXT_LEN_MIN) + OPT_NEXT_SEP;
      while(true){   // While Line not found.
         string   line = FileReadString(handleOPT);
         if(      line == ""){
            AlertMe( "OptInitialization: Error ", GetLastError(),
                                          " reading OPT file for: ", modeNext);
            FileClose(handleOPT);   Opt_Mode = EMPTY;    return;              }
         if(      StringAt(line, "//") != EMPTY)   continue;      // Comment.
         int      parmsBeg = StringAtPast(line, modeNext, Opt_Mode_BEG);
         if(      parmsBeg >= 0){                                 // Found it
            while(!hasSetParms){       // Read and set all params from the line.
               int         nameEnd  = StringFind(line, OPT_NAME_SEP, parmsBeg);
               if(         nameEnd < 0){  hasSetParms = true;  break;   }
                  int      valueBeg = nameEnd + OPT_NAME_SEP_LEN, // Skip equals
                           valueEnd = StringFind(line, OPT_VAL_SEP, valueBeg+1);
               string   name  = StringSubstr(line, parmsBeg,  nameEnd-parmsBeg),
                        value = StringSubstr(line, valueBeg, valueEnd-valueBeg);
               OptSetParameter(name, value);
               parmsBeg = valueEnd + OPT_VAL_SEP_LEN;                // Skip tab
            }
            opt_balance[mode+1] = SubstrToDouble(line,OPT_BAL_BEG,OPT_BAL_LEN);
                           trToInteger(line, OPT_PASS_BEG, OPT_PASS_LEN);
            break;   // Line found
         }  // parmsBeg >= 0
      }  // While Line not found.
      FileSeek(handleOPT, 0, SEEK_SET);   // Rewind.
   }  // For modes
   if(!hasSetParms){
      AlertMe( "OptInitialization: Error ", GetLastError(),
                                    " reading OPT file for: ", modeNext);
      FileClose(handleOPT);   Opt_Mode = EMPTY;    return;                    }
   modeNext =  Opt_Mode + Opt_Mode_SEP;               // Highest next.
   while(true){   // Not EOF
      line = FileReadString(handleOPT);
      if(line == "")                      break;         // EOF
      if(StringAt(line, "//") != EMPTY)   continue;      // Comment.
      int   nextBeg  = StringAtPast(line, modeNext, Opt_Mode_BEG);
      if(nextBeg >= 0){    // In case file resorted, use highest plus one.
            int      nextEnd  = StringFind(line, OPT_NEXT_SEP, nextBeg+1);
         int      next  = SubstrToInteger(line, nextBeg, nextEnd - nextBeg);
         if(next >= opt_next) opt_next = next + 1;
      }
   }   // Not EOF
   FileClose(handleOPT);
   if(Opt_Mode == 0) Opt_Counter = opt_next;
   LogMe( "#" + RJust(Opt_Counter, OPT_PASS_LEN)
         + OPT_PASS_SEP + Opt_Mode
         + Opt_Mode_SEP + opt_next
         + " inputs: ", OptGetParameters() );
   return;
}  // OptInitialization
string   opt_parameters,                           // Export to OptComplete and
         opt_var_name, opt_var_value;              // Export to OptMapToXXX
string   OptGetParameters(){                       // Sets opt_parameters
   opt_parameters = "";                            // Initialize for append(s).
   opt_var_name   = "";    OptMapParameters();     // Append ALL variables.
   return(opt_parameters);                                                    }
void     OptSetParameter(string name, string value){  // Sets &name = value;
   opt_var_name = name; opt_var_value = value;  OptMapParameters();           }
void     OptMapToInt(string name, int& value, int sw=0){
// string   opt_var_name, opt_var_value;     // \ Import from OptGetParameters
//          opt_parameters                   // / or from OptSetParameter
   name  = StringTrimRight(name);            // OptMapParameters formatting.
   if      (opt_var_name == ""){
      string   s="";    if(sw < 0){ sw = -sw;   if(value >= 0) s="+";   }
      opt_parameters = opt_parameters
                     + name + OPT_NAME_SEP
                     + RJust(s+value, sw) + OPT_VAL_SEP;
   }
   else  if(opt_var_name == name)            // Found name to variable. Set it.
      value = StrToInteger(opt_var_value);
// else  not a match.
}
void     OptMapToDouble(string name, double& value, int sw=0){
   name = StringTrimRight(name);
   if      (opt_var_name == ""){
      string   s="";    if(sw < 0){ sw = -sw;   if(value >= 0.)   s="+";   }
      opt_parameters = opt_parameters
                     + name + OPT_NAME_SEP            // DToS: 1.60000 -> 1.6
                     + LJust(s+DoubleToString(value), sw) + OPT_VAL_SEP;
   }
   else  if(opt_var_name == name)
      value = StrToDouble(opt_var_value);
}
void     OptComplete(){
   if(!IsTesting())  return;     if(IsVisualMode())   return;
   double   ABend    = AccountBalance(),  ABbeg = opt_balance[0],
            profit   = ABend - ABbeg,     ABtot = opt_balance[Opt_Mode]+profit;
   int   iNew = Opt_Mode + 1; // Initial balance @ 0 Last balance @ Opt_Mode
   opt_balance[iNew] = ABtot; // New balance
                                                                                 //{
                                                                                 //Log("balances="+ArrayToStr(opt_balance,iNew+1,0,2));
                                                                                 // balances={10000.00,40358.87,39354.44,39948.01,40140.52}
                                                                                 // balances={10000.00,40358.87,39354.44,39948.01,40140.52}
                                                                                 //     cash={         30358.87,-1004.43,  593.57,  192.51}
                                                                                 //                    4.0359 * 0.9751 * 1.0151 * 1.0048 = 4.0141
                                                                                 //  10000 * 1.4155^4 = 10000 * 4.0141 = 40141
                                                                                 //   42% $  40140.52 # 2570/3/2510
                                                                                 //
                                                                                 // 10000.00                   Harm  geo      10000.00                   Harm  geo
                                                                                 // 40358.87 30358.87 4.0359   4.036 4.036    17535.13 7535.13  1.7535   1.754 1.754
                                                                                 // 39354.44 -1004.43 0.9751   1.571 1.984    25070.26 7535.13  1.4297   1.575 1.583
                                                                                 // 39948.01   593.57 1.0151   1.328 1.587    32605.39 7535.13  1.3006   1.472 1.483
                                                                                 // 40140.52   192.51 1.0048   1.229 1.415    40140.52 7535.13  1.2311   1.403 1.415
                                                                                 // 40140.52     0    1.0000   1.175 1.320    40140.52    0.00  1.0000   1.298 1.320
                                                                                 // 40140.52     0    1.0000   1.142 1.261    40140.52    0.00  1.0000   1.237 1.261
                                                                                 //
                                                                                 //                   1.1500   1.150 1.150
                                                                                 //                   0.9000   1.010 1.017
                                                                                 //                   1.0500   1.023 1.028
   // http://www.investopedia.com/articles/08/annualized-returns.asp says
   // geometric average of percentages is best.
   // +15% -10% +5% same as 3 years @ 2.8% -> (1.15)*(0.9)*(1.05)^1/3 = 1.0281
   // 100*[Prod{pct1+1, pct2+1, pct3+1}^^(1/3) - 1]
   // But geometric doesn't care how the total got there, harmonic does. Higher
   // harmonic means more consistency.
                                                                                 //}
   double   Hrates = 1, Einv = 0;
   for(int iBal = iNew; iBal > 0; iBal--){
               profit   = opt_balance[iBal] - opt_balance[iBal-1];
      double   rate     = profit / opt_balance[iBal-1] + 1.0;
      Hrates *= rate;   Einv  += 1./rate;
                                                                                 //Log("rate["+iBal+"]="+rate," H="+Hrates," E="+Einv);
   }
                                                                                 //{balances={10000.00,10019.08,9807.19}
                                                                                 //  profits={10000.00,19.08,-211.89}
                                                                                 // rate[2]=0.97885164 H=0.97885164 E=1.02160528
                                                                                 // rate[1]=1.00190800 H=0.98071929 E=2.01970091
                                                                                 //}    0%    0% $    9807.19 #  254/1/1
   int   geom = (MathPow(Hrates, 1./iNew) - 1.) * 100. + 0.5,
         harm = (iNew / Einv              - 1.) * 100. + 0.5;
   string result  = RJust(                harm, OPT_HAR_LEN)   + OPT_HAR_SEP
                  + RJust(                geom, OPT_GEO_LEN)   + OPT_GEO_SEP
                  + RJust(DoubleToStr(ABtot,2), OPT_BAL_LEN)   + OPT_BAL_SEP
                  + RJust(         Opt_Counter, OPT_PASS_LEN)  + OPT_PASS_SEP
                  + Opt_Mode                                   + Opt_Mode_SEP
                  + LJust(opt_next, OPT_NEXT_LEN_MIN);
   Log(result);
   if(Opt_Mode == EMPTY)               return;        // No entry for loosers.
   if(harm <= Opt_Mode)                return;        // No entry for loosers.
   int         APPEND   = FILE_CSV|FILE_WRITE|FILE_READ;
   string      nameOPT  = WindowExpertName() + ".OPT";
   int      handleOPT   = FileOpen(nameOPT, APPEND, '~');   if(handleOPT < 1){
      AlertMe( "OptComplete: FileOpen(", nameOPT,") Failed: ", GetLastError() );
                                                                     return;  }
   FileSeek(handleOPT, 0, SEEK_END);
   // " har% geo% $tot #cnt/mod/nxt<tab>N1=V1<tab>N2=V2<tab>...<tab>"
   FileWrite( handleOPT, result + OPT_NEXT_SEP
      + OptGetParameters() // In case externals were modified, use modified ones
   );                      // Modified as in initially out of range - corrected.
   FileClose(handleOPT);
}  // OptComplete
int      SubstrToInteger(string what, int start=0, int count=EMPTY){
   string   substr   = StringSubstr(what, start, count);
   int      value    = StrToInteger(substr);                   return(value); }
double   SubstrToDouble(string what, int start=0, int count=EMPTY){
   string   substr   = StringSubstr(what, start, count);
   double   value    = StrToDouble(substr);                    return(value); }
int      StringAtPast(string text, string what, int start=0){
   int   len      = StringLen(what);
   if( StringSubstr(text, start, len) == what ) return(start+len);
   return(EMPTY);                                                             }
string   RJust(string s, int size, string fill=" "){
   for(int n=size-StringLen(s); n > 0; n--)  s = fill+s;    return(s);        }
string   LJust(string s, int size, string fill=" "){
   for(int n=size-StringLen(s); n > 0; n--)  s = s+fill;    return(s);        }
string   DoubleToString(double v, int d=8){              // 1.60000000 -> 1.6
   string   value = DoubleToStr(v, d);
   for(int iRight = StringLen(value)-1; true; iRight--){
      int      c = StringGetChar(value, iRight);
      if(c != '0'){
         if(c == '.') iRight--;
         break;
      }
   }
   return( StringSubstr(value, 0, iRight+1) );
}
//{Log
// send information to OutputDebugString() to be viewed and logged by
// SysInternal's DebugView (free download from Microsoft) This is ideal for
// debugging as an alternative to Print(). The function will take up to 10
// strings (or numeric) arguments to be concatenated into one debug message.
// http://technet.microsoft.com/en-us/sysinternals/bb896647.aspx
//}
#import "kernel32.dll"
   void     OutputDebugStringA(string msg);
#import
// int init(){                                           #define CS_LIVE      0
//                                                       #define CS_VISUAL    1
// if      (!IsTesting())     status.chart   = CS_LIVE;  #define CS_OPTIMIZER 2
// else  if(IsVisualMode())   status.chart   = CS_VISUAL;
// else{                      status.chart   = CS_OPTIMIZER;
//                            Show.Comments  = false;
//                            Show.Objects   = false;                         }
// ...}
void     Log(string s1, string s2="", string s3="", string s4="", string s5="",
         string s6="", string s7="", string s8="", string s9="", string s10=""){
   if( IsDllsAllowed() ){
      if(status.chart == CS_LIVE)   string out = "";
      else  // Visual or Optimizer
         out = TimeToStr(timeCur.srv, TIME_DATE|TIME_MINUTES|TIME_SECONDS) +" ";
      out   = out + WindowExpertName() + ": "
                  + s1 + s2 + s3 + s4 + s5 + s6 + s7 + s8 + s9 + s10;
      OutputDebugStringA(out);
}  }
void  AlertMe(string s1, string s2="", string s3="", string s4="", string s5="",
         string s6="", string s7="", string s8="", string s9="", string s10=""){
   Alert(s1, s2, s3, s4, s5, s6, s7, s8, s9, s10);
     Log(s1, s2, s3, s4, s5, s6, s7, s8, s9, s10);
}
